#define USE_FIXED

#include "sbc.h"
#include "sbc_tables.h"

struct {
	char *name;
	void *ref;
	int i;
	int j;
} tables[] = {
	{"sbc_proto_4_40_f", (void *)sbc_proto_4_40, 40, 1},
	{"sbc_proto_8_80_f", (void *)sbc_proto_8_80, 80, 1},
	{"synmatrix4_f", (void *)synmatrix4, 8, 4},
	{"synmatrix8_f", (void *)synmatrix8, 16, 8},
	{"anamatrix4_f", (void *)anamatrix4, 4, 8},
	{"anamatrix8_f", (void *)anamatrix8, 8, 16},
	{0, 0, 0, 0}
};

int main(int argc, char **argv) {
	int entry, i, j, idx;
	float *array;
	for(entry = 0; tables[entry].name; entry++) {
		if(tables[entry].j == 1) {
			printf("static const sbc_fixed_t %s[%d] = {\n",
			       tables[entry].name, tables[entry].i);
			array = (float *)tables[entry].ref;
			for(i = 0; i < tables[entry].i; i++) {
				if(i>0) {
					printf(", ");
					if(i%8 == 0) printf("\n");
				}
				printf("0x%08x", dtofixed(array[i]));
			}
			printf("\n};\n\n");
		} else {
			printf("static const sbc_fixed_t %s[%d][%d] = {\n",
			       tables[entry].name, tables[entry].i, tables[entry].j);
			array = (float *)tables[entry].ref;
			idx = 0;
			for(i = 0; i < tables[entry].i; i++) {
				if(i>0) printf(",\n");
				printf("{ ");
				for(j = 0; j < tables[entry].j; j++) {
					if(j>0) {
						printf(", ");
						if(j%8 == 0) printf("\n");
					}
					printf("0x%08x", dtofixed(array[idx++]));
				}
				printf(" }");
			}
			printf("\n};\n\n");
		}
	}
}
